﻿using System;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Windows.Forms;

namespace FlexChart_AxisScrollBar
{
    public partial class Form1 : Form
    {
        //use this to set the AxisY's minimum value instead of AxisY.Min
        //because AxisY.Min is set by adjusting the RangeSlider between the chart and the AxisX
        double AxisYMin = 0;
        //similar for AxisX
        double AxisXMin = 0;
        public Form1()
        {
            InitializeComponent();

            var rnd = new Random();
            flexChart1.DataSource = Enumerable.Range(1, 100).Select(i => new Point(i, rnd.Next(10)));
            flexChart1.Binding = "Y";
            flexChart1.BindingX = "X";
            AxisYMin = 0;
            AxisXMin = 0;

            c1RangeSliderX.Minimum = 0.5;
            c1RangeSliderX.Maximum = 100.5;
            c1RangeSliderY.Minimum = -0.5;
            c1RangeSliderY.Maximum = 10.5;
            c1RangeSliderX.ValueChanged += (s, e) =>
            {
                AxisXMin = c1RangeSliderX.LowerValue;
                flexChart1.AxisX.Max = c1RangeSliderX.UpperValue;

                flexChart1.Refresh();
            };
            c1RangeSliderY.ValueChanged += (s, e) =>
            {
                AxisYMin = c1RangeSliderY.LowerValue;
                flexChart1.AxisY.Max = c1RangeSliderY.UpperValue;

                flexChart1.Refresh();
            };
            c1RangeSliderX.LowerValue = 0.5;
            c1RangeSliderX.UpperValue = 20.5;

            flexChart1.Rendered += FlexChart1_Rendered;
        }

        private void FlexChart1_Rendered(object sender, C1.Win.Chart.RenderEventArgs e)
        {
            //AxisX
            c1RangeSliderX.Location = new Point((int)flexChart1.PlotRect.Left + c1RangeSliderY.Width, (int)(flexChart1.PlotRect.Bottom - c1RangeSliderX.Height));
            c1RangeSliderX.Width = (int)(flexChart1.PlotRect.Width - c1RangeSliderY.Width) - 2;
            flexChart1.AxisY.Min = AxisYMin + flexChart1.AxisY.ConvertBack(flexChart1.AxisY.Convert(0) + c1RangeSliderX.Height + 2);

            //AxisY
            c1RangeSliderY.Location = new Point((int)flexChart1.PlotRect.Left, (int)(flexChart1.PlotRect.Top));
            c1RangeSliderY.Height = (int)(flexChart1.PlotRect.Height - c1RangeSliderX.Height) - 2;
            flexChart1.AxisX.Min = AxisXMin + flexChart1.AxisX.ConvertBack(flexChart1.AxisX.Convert(0) + c1RangeSliderY.Width + 2);
        }
    }
}
